#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "Fish_TherionLevelCFG.h"
#include "FileEncrypt.h"
std::auto_ptr<Fish_TherionLevelCFG> Fish_TherionLevelCFG::msSingleton(nullptr);

int Fish_TherionLevelCFG::GetCount()
{
	return (int)mMapData.size();
}

const Fish_TherionLevelCFGData* Fish_TherionLevelCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, Fish_TherionLevelCFGData>& Fish_TherionLevelCFG::GetMapData()
{
	return mMapData;
}

void Fish_TherionLevelCFG::Reload()
{
	mMapData.clear();
	Load();
}

void Fish_TherionLevelCFG::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_TherionLevelCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mLevel = element->IntAttribute("Level");
		data.mTherionIntegral = element->IntAttribute("TherionIntegral");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		assert(mMapData.find(data.mID) == mMapData.end());
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
}

void Fish_TherionLevelCFG::Load()
{
	Load("../Config/Fish_TherionLevelCFG.xml");
}

Fish_TherionLevelCFG* Fish_TherionLevelCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_TherionLevelCFG());
	}
	return msSingleton.get();
}
